glibmm: Glib::DateTime Class Reference

glibmm 2.31.0.2

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Examples

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | Protected Attributes | Related Functions
Glib::DateTime Class Reference

DateTime - A structure representing Date and Time. More...

`#include <glibmm/datetime.h>`

List of all members.

## Public Member Functions
| DateTime ()
| DateTime (GDateTime* castitem, bool make_a_copy=false)
| DateTime (const DateTime& src)
DateTime& | operator= (const DateTime& src)
| ~DateTime ()
GDateTime* | gobj ()
const GDateTime* | gobj () const
GDateTime* | gobj_copy () const
| Provides access to the underlying C instance. The caller is responsible for freeing it. Use when directly setting fields in structs.
DateTime | add (TimeSpan timespan) const
| Creates a copy of datetime and adds the specified timespan to the copy.
DateTime | add_years (int years) const
| Creates a copy of datetime and adds the specified number of years to the copy.
DateTime | add_months (int months) const
| Creates a copy of datetime and adds the specified number of months to the copy.
DateTime | add_weeks (int weeks) const
| Creates a copy of datetime and adds the specified number of weeks to the copy.
DateTime | add_days (int days) const
| Creates a copy of datetime and adds the specified number of days to the copy.
DateTime | add_hours (int hours) const
| Creates a copy of datetime and adds the specified number of hours.
DateTime | add_minutes (int minutes) const
| Creates a copy of datetime adding the specified number of minutes.
DateTime | add_seconds (double seconds) const
| Creates a copy of datetime and adds the specified number of seconds.
DateTime | add_full (int years, int months, int days, int hours, int minutes, double seconds) const
| Creates a new DateTime adding the specified values to the current date and time in datetime.
TimeSpan | difference (const DateTime& other) const
| Calculates the difference in time between end and begin.
int | compare (const DateTime& other) const
| A comparison function for DateTimes that is suitable as a CompareFunc.
guint | hash () const
| Hashes datetime into a `unsigned int`, suitable for use within HashTable.
bool | equal (const DateTime& other) const
| Checks to see if dt1 and dt2 are equal.
void | get_ymd (int& year, int& month, int& day) const
| Retrieves the Gregorian day, month, and year of a given DateTime.
int | get_year () const
| Retrieves the year represented by datetime in the Gregorian calendar.
int | get_month () const
| Retrieves the month of the year represented by datetime in the Gregorian calendar.
int | get_day_of_month () const
| Retrieves the day of the month represented by datetime in the gregorian calendar.
int | get_week_numbering_year () const
| Returns the ISO 8601 week-numbering year in which the week containing datetime falls.
int | get_week_of_year () const
| Returns the ISO 8601 week number for the week containing datetime.
int | get_day_of_week () const
| Retrieves the ISO 8601 day of the week on which datetime falls (1 is Monday, 2 is Tuesday...
int | get_day_of_year () const
| Retrieves the day of the year represented by datetime in the Gregorian calendar.
int | get_hour () const
| Retrieves the hour of the day represented by datetime.
int | get_minute () const
| Retrieves the minute of the hour represented by datetime.
int | get_second () const
| Retrieves the second of the minute represented by datetime.
int | get_microsecond () const
| Retrieves the microsecond of the date represented by datetime.
double | get_seconds () const
| Retrieves the number of seconds since the start of the last minute, including the fractional part.
gint64 | to_unix () const
| Gives the Unix time corresponding to datetime, rounding down to the nearest second.
bool | to_timeval (TimeVal& tv) const
| Stores the instant in time that datetime represents into tv.
TimeSpan | get_utc_offset () const
| Determines the offset to UTC in effect at the time and in the time zone of datetime.
Glib::ustring | get_timezone_abbreviation () const
| Determines the time zone abbreviation to be used at the time and in the time zone of datetime.
bool | is_daylight_savings () const
| Determines if daylight savings time is in effect at the time and in the time zone of datetime.
DateTime | to_timezone (const TimeZone& tz) const
| Create a new DateTime corresponding to the same instant in time as datetime, but in the time zone tz.
DateTime | to_local () const
| Creates a new DateTime corresponding to the same instant in time as datetime, but in the local time zone.
DateTime | to_utc () const
| Creates a new DateTime corresponding to the same instant in time as datetime, but in UTC.
Glib::ustring | format (const Glib::ustring& format) const
| Creates a newly allocated string representing the requested format.
## Static Public Member Functions
static DateTime | create_now (const TimeZone& tz)
| Creates a DateTime corresponding to this exact instant in the given time zone tz.
static DateTime | create_now_local ()
| Creates a DateTime corresponding to this exact instant in the local time zone.
static DateTime | create_now_utc ()
| Creates a DateTime corresponding to this exact instant in UTC.
static DateTime | create_now_local (gint64 t)
| Creates a DateTime corresponding to the given Unix time t in the local time zone.
static DateTime | create_now_utc (gint64 t)
| Creates a DateTime corresponding to the given Unix time t in UTC.
static DateTime | create_now_local (const TimeVal& tv)
| Creates a DateTime corresponding to the given TimeVal tv in the local time zone.
static DateTime | create_now_utc (const TimeVal& tv)
| Creates a DateTime corresponding to the given TimeVal tv in UTC.
static DateTime | create (const TimeZone& tz, int year, int month, int day, int hour, int minute, double seconds)
| Creates a new DateTime corresponding to the given date and time in the time zone tz.
static DateTime | create_local (int year, int month, int day, int hour, int minute, double seconds)
| Creates a new DateTime corresponding to the given date and time in the local time zone.
static DateTime | create_utc (int year, int month, int day, int hour, int minute, double seconds)
| Creates a new DateTime corresponding to the given date and time in UTC.
## Protected Attributes
GDateTime* | gobject_
## Related Functions
(Note that these are not member functions.)
Glib::DateTime | wrap (GDateTime* object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Detailed Description

DateTime - A structure representing Date and Time.

DateTime is a structure that combines a Gregorian date and time into a single structure. It provides many conversion and methods to manipulate dates and times. Time precision is provided down to microseconds and the time can range (proleptically) from 0001-01-01 00:00:00 to 9999-12-31 23:59:59.999999. DateTime follows POSIX time in the sense that it is oblivious to leap seconds.

DateTime is an immutable object; once it has been created it cannot be modified further. All modifiers will create a new DateTime. Nearly all such functions can fail due to the date or time going out of range, in which case `0` will be returned.

DateTime is reference counted. When the reference count drops to 0, the resources allocated by the DateTime structure are released.

Many parts of the API may produce non-obvious results. As an example, adding two months to January 31st will yield March 31st whereas adding one month and then one month again will yield either March 28th or March 29th. Also note that adding 24 hours is not always the same as adding one day (since days containing daylight savings time transitions are either 23 or 25 hours in length).

Since glibmm 2.30:

## Constructor & Destructor Documentation

Glib::DateTime::DateTime | ( |  | ) |

Glib::DateTime::DateTime | ( | GDateTime * | castitem,
|  | bool | make_a_copy = `false`
| ) |  | `[explicit]`

Glib::DateTime::DateTime | ( | const DateTime& | src | ) |

Glib::DateTime::~DateTime | ( |  | ) |

## Member Function Documentation

DateTime Glib::DateTime::add | ( | TimeSpan | timespan | ) | const

Creates a copy of datetime and adds the specified timespan to the copy.

Since glibmm 2.26:

Parameters:

  timespan | A TimeSpan.

Returns:
  The newly created DateTime which should be freed with g_date_time_unref().

DateTime Glib::DateTime::add_days | ( | int | days | ) | const

Creates a copy of datetime and adds the specified number of days to the copy.

Since glibmm 2.26:

Parameters:

  days | The number of days.

Returns:
  The newly created DateTime which should be freed with g_date_time_unref().

DateTime Glib::DateTime::add_full | ( | int | years,
|  | int | months,
|  | int | days,
|  | int | hours,
|  | int | minutes,
|  | double | seconds
| ) |  | const

Creates a new DateTime adding the specified values to the current date and time in datetime.

Since glibmm 2.26:

Parameters:

  years | The number of years to add.
  months | The number of months to add.
  days | The number of days to add.
  hours | The number of hours to add.
  minutes | The number of minutes to add.
  seconds | The number of seconds to add.

Returns:
  The newly created DateTime that should be freed with g_date_time_unref().

DateTime Glib::DateTime::add_hours | ( | int | hours | ) | const

Creates a copy of datetime and adds the specified number of hours.

Since glibmm 2.26:

Parameters:

  hours | The number of hours to add.

Returns:
  The newly created DateTime which should be freed with g_date_time_unref().

DateTime Glib::DateTime::add_minutes | ( | int | minutes | ) | const

Creates a copy of datetime adding the specified number of minutes.

Since glibmm 2.26:

Parameters:

  minutes | The number of minutes to add.

Returns:
  The newly created DateTime which should be freed with g_date_time_unref().

DateTime Glib::DateTime::add_months | ( | int | months | ) | const

Creates a copy of datetime and adds the specified number of months to the copy.

Since glibmm 2.26:

Parameters:

  months | The number of months.

Returns:
  The newly created DateTime which should be freed with g_date_time_unref().

DateTime Glib::DateTime::add_seconds | ( | double | seconds | ) | const

Creates a copy of datetime and adds the specified number of seconds.

Since glibmm 2.26:

Parameters:

  seconds | The number of seconds to add.

Returns:
  The newly created DateTime which should be freed with g_date_time_unref().

DateTime Glib::DateTime::add_weeks | ( | int | weeks | ) | const

Creates a copy of datetime and adds the specified number of weeks to the copy.

Since glibmm 2.26:

Parameters:

  weeks | The number of weeks.

Returns:
  The newly created DateTime which should be freed with g_date_time_unref().

DateTime Glib::DateTime::add_years | ( | int | years | ) | const

Creates a copy of datetime and adds the specified number of years to the copy.

Since glibmm 2.26:

Parameters:

  years | The number of years.

Returns:
  The newly created DateTime which should be freed with g_date_time_unref().

int Glib::DateTime::compare | ( | const DateTime& | other | ) | const

A comparison function for DateTimes that is suitable as a CompareFunc.

Both DateTimes must be non-`0`.

Since glibmm 2.26:

Parameters:

  dt1 | First DateTime to compare.
  dt2 | Second DateTime to compare.

Returns:
  -1, 0 or 1 if dt1 is less than, equal to or greater than dt2.

static DateTime Glib::DateTime::create | ( | const TimeZone& | tz,
|  | int | year,
|  | int | month,
|  | int | day,
|  | int | hour,
|  | int | minute,
|  | double | seconds
| ) |  | `[static]`

Creates a new DateTime corresponding to the given date and time in the time zone tz.

The year must be between 1 and 9999, month between 1 and 12 and day between 1 and 28, 29, 30 or 31 depending on the month and the year.

hour must be between 0 and 23 and minute must be between 0 and 59.

seconds must be at least 0.0 and must be strictly less than 60.0. It will be rounded down to the nearest microsecond.

If the given time is not representable in the given time zone (for example, 02:30 on March 14th 2010 in Toronto, due to daylight savings time) then the time will be rounded up to the nearest existing time (in this case, 03:00). If this matters to you then you should verify the return value for containing the same as the numbers you gave.

In the case that the given time is ambiguous in the given time zone (for example, 01:30 on November 7th 2010 in Toronto, due to daylight savings time) then the time falling within standard (ie: non-daylight) time is taken.

It not considered a programmer error for the values to this function to be out of range, but in the case that they are, the function will return `0`.

You should release the return value by calling g_date_time_unref() when you are done with it.

Since glibmm 2.26:

Parameters:

  tz | A TimeZone.
  year | The year component of the date.
  month | The month component of the date.
  day | The day component of the date.
  hour | The hour component of the date.
  minute | The minute component of the date.
  seconds | The number of seconds past the minute.

Returns:
  A new DateTime, or `0`.

static DateTime Glib::DateTime::create_local | ( | int | year,
|  | int | month,
|  | int | day,
|  | int | hour,
|  | int | minute,
|  | double | seconds
| ) |  | `[static]`

Creates a new DateTime corresponding to the given date and time in the local time zone.

This call is equivalent to calling g_date_time_new() with the time zone returned by g_time_zone_new_local().

Since glibmm 2.26:

Parameters:

  year | The year component of the date.
  month | The month component of the date.
  day | The day component of the date.
  hour | The hour component of the date.
  minute | The minute component of the date.
  seconds | The number of seconds past the minute.

Returns:
  A DateTime, or `0`.

static DateTime Glib::DateTime::create_now | ( | const TimeZone& | tz | ) | `[static]`

Creates a DateTime corresponding to this exact instant in the given time zone tz.

The time is as accurate as the system allows, to a maximum accuracy of 1 microsecond.

This function will always succeed unless the system clock is set to truly insane values (or unless GLib is still being used after the year 9999).

You should release the return value by calling g_date_time_unref() when you are done with it.

Since glibmm 2.26:

Parameters:

  tz | A TimeZone.

Returns:
  A new DateTime, or `0`.

static DateTime Glib::DateTime::create_now_local | ( | gint64 | t | ) | `[static]`

Creates a DateTime corresponding to the given Unix time t in the local time zone.

Unix time is the number of seconds that have elapsed since 1970-01-01 00:00:00 UTC, regardless of the local time offset.

This call can fail (returning `0`) if t represents a time outside of the supported range of DateTime.

You should release the return value by calling g_date_time_unref() when you are done with it.

Since glibmm 2.26:

Parameters:

  t | The Unix time.

Returns:
  A new DateTime, or `0`.

static DateTime Glib::DateTime::create_now_local | ( | const TimeVal& | tv | ) | `[static]`

Creates a DateTime corresponding to the given TimeVal tv in the local time zone.

The time contained in a TimeVal is always stored in the form of seconds elapsed since 1970-01-01 00:00:00 UTC, regardless of the local time offset.

This call can fail (returning `0`) if tv represents a time outside of the supported range of DateTime.

You should release the return value by calling g_date_time_unref() when you are done with it.

Since glibmm 2.26:

Parameters:

  tv | A TimeVal.

Returns:
  A new DateTime, or `0`.

static DateTime Glib::DateTime::create_now_local | ( |  | ) | `[static]`

Creates a DateTime corresponding to this exact instant in the local time zone.

This is equivalent to calling g_date_time_new_now() with the time zone returned by g_time_zone_new_local().

Since glibmm 2.26:

Returns:
  A new DateTime, or `0`.

static DateTime Glib::DateTime::create_now_utc | ( | gint64 | t | ) | `[static]`

Creates a DateTime corresponding to the given Unix time t in UTC.

Unix time is the number of seconds that have elapsed since 1970-01-01 00:00:00 UTC.

This call can fail (returning `0`) if t represents a time outside of the supported range of DateTime.

You should release the return value by calling g_date_time_unref() when you are done with it.

Since glibmm 2.26:

Parameters:

  t | The Unix time.

Returns:
  A new DateTime, or `0`.

static DateTime Glib::DateTime::create_now_utc | ( | const TimeVal& | tv | ) | `[static]`

Creates a DateTime corresponding to the given TimeVal tv in UTC.

The time contained in a TimeVal is always stored in the form of seconds elapsed since 1970-01-01 00:00:00 UTC.

This call can fail (returning `0`) if tv represents a time outside of the supported range of DateTime.

You should release the return value by calling g_date_time_unref() when you are done with it.

Since glibmm 2.26:

Parameters:

  tv | A TimeVal.

Returns:
  A new DateTime, or `0`.

static DateTime Glib::DateTime::create_now_utc | ( |  | ) | `[static]`

Creates a DateTime corresponding to this exact instant in UTC.

This is equivalent to calling g_date_time_new_now() with the time zone returned by g_time_zone_new_utc().

Since glibmm 2.26:

Returns:
  A new DateTime, or `0`.

static DateTime Glib::DateTime::create_utc | ( | int | year,
|  | int | month,
|  | int | day,
|  | int | hour,
|  | int | minute,
|  | double | seconds
| ) |  | `[static]`

Creates a new DateTime corresponding to the given date and time in UTC.

This call is equivalent to calling g_date_time_new() with the time zone returned by g_time_zone_new_utc().

Since glibmm 2.26:

Parameters:

  year | The year component of the date.
  month | The month component of the date.
  day | The day component of the date.
  hour | The hour component of the date.
  minute | The minute component of the date.
  seconds | The number of seconds past the minute.

Returns:
  A DateTime, or `0`.

TimeSpan Glib::DateTime::difference | ( | const DateTime& | other | ) | const

Calculates the difference in time between end and begin.

The TimeSpan that is returned is effectively end - begin (ie: positive if the first simparameter is larger).

Since glibmm 2.26:

Parameters:

  begin | A DateTime.

Returns:
  The difference between the two DateTime, as a time span expressed in microseconds.

bool Glib::DateTime::equal | ( | const DateTime& | other | ) | const

Checks to see if dt1 and dt2 are equal.

Equal here means that they represent the same moment after converting them to the same time zone.

Since glibmm 2.26:

Parameters:

  dt1 | A DateTime.
  dt2 | A DateTime.

Returns:
  `true` if dt1 and dt2 are equal.

Glib::ustring Glib::DateTime::format | ( | const Glib::ustring& | format | ) | const

Creates a newly allocated string representing the requested format.

The format strings understood by this function are a subset of the strftime() format language. In contrast to strftime(), this function always produces a UTF-8 string, regardless of the current locale. Note that the rendering of many formats is locale-dependent and may not match the strftime() output exactly.

The following format specifiers are supported:

<variablelist> <varlistentry> `%a`: <listitem><simpara> the abbreviated weekday name according to the current locale </simpara></listitem></varlistentry> <varlistentry> `%A`: <listitem><simpara> the full weekday name according to the current locale </simpara></listitem></varlistentry> <varlistentry> `%b`: <listitem><simpara> the abbreviated month name according to the current locale </simpara></listitem></varlistentry> <varlistentry> `%B`: <listitem><simpara> the full month name according to the current locale </simpara></listitem></varlistentry> <varlistentry> `%d`: <listitem><simpara> the day of the month as a decimal number (range 01 to 31) </simpara></listitem></varlistentry> <varlistentry> `%e`: <listitem><simpara> the day of the month as a decimal number (range 1 to 31) </simpara></listitem></varlistentry> <varlistentry> `%F`: <listitem><simpara> equivalent to `%Y-%m-%d` (the ISO 8601 date format) </simpara></listitem></varlistentry> <varlistentry> `%h`: <listitem><simpara> equivalent to `%b` </simpara></listitem></varlistentry> <varlistentry> `%H`: <listitem><simpara> the hour as a decimal number using a 24-hour clock (range 00 to 23) </simpara></listitem></varlistentry> <varlistentry> `%I`: <listitem><simpara> the hour as a decimal number using a 12-hour clock (range 01 to 12) </simpara></listitem></varlistentry> <varlistentry> `%j`: <listitem><simpara> the day of the year as a decimal number (range 001 to 366) </simpara></listitem></varlistentry> <varlistentry> `%k`: <listitem><simpara> the hour (24-hour clock) as a decimal number (range 0 to 23); single digits are preceded by a blank </simpara></listitem></varlistentry> <varlistentry> `%l`: <listitem><simpara> the hour (12-hour clock) as a decimal number (range 1 to 12); single digits are preceded by a blank </simpara></listitem></varlistentry> <varlistentry> `%m`: <listitem><simpara> the month as a decimal number (range 01 to 12) </simpara></listitem></varlistentry> <varlistentry> `%M`: <listitem><simpara> the minute as a decimal number (range 00 to 59) </simpara></listitem></varlistentry> <varlistentry> `%N`: <listitem><simpara> the micro-seconds as a decimal number </simpara></listitem></varlistentry> <varlistentry> `%p`: <listitem><simpara> either "AM" or "PM" according to the given time value, or the corresponding strings for the current locale. Noon is treated as "PM" and midnight as "AM". </simpara></listitem></varlistentry> <varlistentry> `%P`: <listitem><simpara> like %p but lowercase: "am" or "pm" or a corresponding string for the current locale </simpara></listitem></varlistentry> <varlistentry> `%r`: <listitem><simpara> the time in a.m. or p.m. notation </simpara></listitem></varlistentry> <varlistentry> `%R`: <listitem><simpara> the time in 24-hour notation (`%H:%M`) </simpara></listitem></varlistentry> <varlistentry> `%s`: <listitem><simpara> the number of seconds since the Epoch, that is, since 1970-01-01 00:00:00 UTC </simpara></listitem></varlistentry> <varlistentry> `%S`: <listitem><simpara> the second as a decimal number (range 00 to 60) </simpara></listitem></varlistentry> <varlistentry> `%t`: <listitem><simpara> a tab character </simpara></listitem></varlistentry> <varlistentry> `%u`: <listitem><simpara> the day of the week as a decimal, range 1 to 7, Monday being 1 </simpara></listitem></varlistentry> <varlistentry> `%W`: <listitem><simpara> the week number of the current year as a decimal number </simpara></listitem></varlistentry> <varlistentry> `%x`: <listitem><simpara> the preferred date representation for the current locale without the time </simpara></listitem></varlistentry> <varlistentry> `%X`: <listitem><simpara> the preferred time representation for the current locale without the date </simpara></listitem></varlistentry> <varlistentry> `%y`: <listitem><simpara> the year as a decimal number without the century </simpara></listitem></varlistentry> <varlistentry> `%Y`: <listitem><simpara> the year as a decimal number including the century </simpara></listitem></varlistentry> <varlistentry> `%z`: <listitem><simpara> the time-zone as hour offset from UTC </simpara></listitem></varlistentry> <varlistentry> `%Z`: <listitem><simpara> the time zone or name or abbreviation </simpara></listitem></varlistentry> <varlistentry> `%%%`: <listitem><simpara> a literal `%%` character </simpara></listitem></varlistentry> </variablelist>

Some conversion specifications can be modified by preceding the conversion specifier by one or more modifier characters. The following modifiers are supported for many of the numeric conversions: <variablelist> <varlistentry> O <listitem> Use alternative numeric symbols, if the current locale supports those. </listitem> </varlistentry> <varlistentry> _ <listitem> Pad a numeric result with spaces. This overrides the default padding for the specifier. </listitem> </varlistentry> <varlistentry> - <listitem> Do not pad a numeric result. This overrides the default padding for the specifier. </listitem> </varlistentry> <varlistentry> 0 <listitem> Pad a numeric result with zeros. This overrides the default padding for the specifier. </listitem> </varlistentry> </variablelist>

Since glibmm 2.26:

Parameters:

  format | A valid UTF-8 string, containing the format for the DateTime.

Returns:
  A newly allocated string formatted to the requested format or `0` in the case that there was an error. The string should be freed with g_free().

int Glib::DateTime::get_day_of_month | ( |  | ) | const

Retrieves the day of the month represented by datetime in the gregorian calendar.

Since glibmm 2.26:

Returns:
  The day of the month.

int Glib::DateTime::get_day_of_week | ( |  | ) | const

Retrieves the ISO 8601 day of the week on which datetime falls (1 is Monday, 2 is Tuesday...

7 is Sunday).

Since glibmm 2.26:

Returns:
  The day of the week.

int Glib::DateTime::get_day_of_year | ( |  | ) | const

Retrieves the day of the year represented by datetime in the Gregorian calendar.

Since glibmm 2.26:

Returns:
  The day of the year.

int Glib::DateTime::get_hour | ( |  | ) | const

Retrieves the hour of the day represented by datetime.

Since glibmm 2.26:

Returns:
  The hour of the day.

int Glib::DateTime::get_microsecond | ( |  | ) | const

Retrieves the microsecond of the date represented by datetime.

Since glibmm 2.26:

Returns:
  The microsecond of the second.

int Glib::DateTime::get_minute | ( |  | ) | const

Retrieves the minute of the hour represented by datetime.

Since glibmm 2.26:

Returns:
  The minute of the hour.

int Glib::DateTime::get_month | ( |  | ) | const

Retrieves the month of the year represented by datetime in the Gregorian calendar.

Since glibmm 2.26:

Returns:
  The month represented by datetime.

int Glib::DateTime::get_second | ( |  | ) | const

Retrieves the second of the minute represented by datetime.

Since glibmm 2.26:

Returns:
  The second represented by datetime.

double Glib::DateTime::get_seconds | ( |  | ) | const

Retrieves the number of seconds since the start of the last minute, including the fractional part.

Since glibmm 2.26:

Returns:
  The number of seconds.

Glib::ustring Glib::DateTime::get_timezone_abbreviation | ( |  | ) | const

Determines the time zone abbreviation to be used at the time and in the time zone of datetime.

For example, in Toronto this is currently "EST" during the winter months and "EDT" during the summer months when daylight savings time is in effect.

Since glibmm 2.26:

Returns:
  The time zone abbreviation. The returned string is owned by the DateTime and it should not be modified or freed.

TimeSpan Glib::DateTime::get_utc_offset | ( |  | ) | const

Determines the offset to UTC in effect at the time and in the time zone of datetime.

The offset is the number of microseconds that you add to UTC time to arrive at local time for the time zone (ie: negative numbers for time zones west of GMT, positive numbers for east).

If datetime represents UTC time, then the offset is always zero.

Since glibmm 2.26:

Returns:
  The number of microseconds that should be added to UTC to get the local time.

int Glib::DateTime::get_week_numbering_year | ( |  | ) | const

Returns the ISO 8601 week-numbering year in which the week containing datetime falls.

This function, taken together with g_date_time_get_week_of_year() and g_date_time_get_day_of_week() can be used to determine the full ISO week date on which datetime falls.

This is usually equal to the normal Gregorian year (as returned by g_date_time_get_year()), except as detailed below:

For Thursday, the week-numbering year is always equal to the usual calendar year. For other days, the number is such that every day within a complete week (Monday to Sunday) is contained within the same week-numbering year.

For Monday, Tuesday and Wednesday occuring near the end of the year, this may mean that the week-numbering year is one greater than the calendar year (so that these days have the same week-numbering year as the Thursday occuring early in the next year).

For Friday, Saturaday and Sunday occuring near the start of the year, this may mean that the week-numbering year is one less than the calendar year (so that these days have the same week-numbering year as the Thursday occuring late in the previous year).

An equivalent description is that the week-numbering year is equal to the calendar year containing the majority of the days in the current week (Monday to Sunday).

Note that January 1 0001 in the proleptic Gregorian calendar is a Monday, so this function never returns 0.

Since glibmm 2.26:

Returns:
  The ISO 8601 week-numbering year for datetime.

int Glib::DateTime::get_week_of_year | ( |  | ) | const

Returns the ISO 8601 week number for the week containing datetime.

The ISO 8601 week number is the same for every day of the week (from Moday through Sunday). That can produce some unusual results (described below).

The first week of the year is week 1. This is the week that contains the first Thursday of the year. Equivalently, this is the first week that has more than 4 of its days falling within the calendar year.

The value 0 is never returned by this function. Days contained within a year but occuring before the first ISO 8601 week of that year are considered as being contained in the last week of the previous year. Similarly, the final days of a calendar year may be considered as being part of the first ISO 8601 week of the next year if 4 or more days of that week are contained within the new year.

Since glibmm 2.26:

Returns:
  The ISO 8601 week number for datetime.

int Glib::DateTime::get_year | ( |  | ) | const

Retrieves the year represented by datetime in the Gregorian calendar.

Since glibmm 2.26:

Returns:
  The year represented by datetime.

void Glib::DateTime::get_ymd | ( | int & | year,
|  | int & | month,
|  | int & | day
| ) |  | const

Retrieves the Gregorian day, month, and year of a given DateTime.

Since glibmm 2.26:

Parameters:

  year | The return location for the gregorian year, or `0`.
  month | The return location for the month of the year, or `0`.
  day | The return location for the day of the month, or `0`.

const GDateTime* Glib::DateTime::gobj | ( |  | ) | const`[inline]`

GDateTime* Glib::DateTime::gobj | ( |  | ) | `[inline]`

GDateTime* Glib::DateTime::gobj_copy | ( |  | ) | const

Provides access to the underlying C instance. The caller is responsible for freeing it. Use when directly setting fields in structs.

guint Glib::DateTime::hash | ( |  | ) | const

Hashes datetime into a `unsigned int`, suitable for use within HashTable.

Since glibmm 2.26:

Parameters:

  datetime | A DateTime.

Returns:
  A `unsigned int` containing the hash.

bool Glib::DateTime::is_daylight_savings | ( |  | ) | const

Determines if daylight savings time is in effect at the time and in the time zone of datetime.

Since glibmm 2.26:

Returns:
  `true` if daylight savings time is in effect.

DateTime& Glib::DateTime::operator= | ( | const DateTime& | src | ) |

DateTime Glib::DateTime::to_local | ( |  | ) | const

Creates a new DateTime corresponding to the same instant in time as datetime, but in the local time zone.

This call is equivalent to calling g_date_time_to_timezone() with the time zone returned by g_time_zone_new_local().

Since glibmm 2.26:

Returns:
  The newly created DateTime.

bool Glib::DateTime::to_timeval | ( | TimeVal& | tv | ) | const

Stores the instant in time that datetime represents into tv.

The time contained in a TimeVal is always stored in the form of seconds elapsed since 1970-01-01 00:00:00 UTC, regardless of the time zone associated with datetime.

On systems where 'long' is 32bit (ie: all 32bit systems and all Windows systems), a TimeVal is incapable of storing the entire range of values that DateTime is capable of expressing. On those systems, this function returns `false` to indicate that the time is out of range.

On systems where 'long' is 64bit, this function never fails.

Since glibmm 2.26:

Parameters:

  tv | A TimeVal to modify.

Returns:
  `true` if successful, else `false`.

DateTime Glib::DateTime::to_timezone | ( | const TimeZone& | tz | ) | const

Create a new DateTime corresponding to the same instant in time as datetime, but in the time zone tz.

This call can fail in the case that the time goes out of bounds. For example, converting 0001-01-01 00:00:00 UTC to a time zone west of Greenwich will fail (due to the year 0 being out of range).

You should release the return value by calling g_date_time_unref() when you are done with it.

Since glibmm 2.26:

Parameters:

  tz | The new TimeZone.

Returns:
  A new DateTime, or `0`.

gint64 Glib::DateTime::to_unix | ( |  | ) | const

Gives the Unix time corresponding to datetime, rounding down to the nearest second.

Unix time is the number of seconds that have elapsed since 1970-01-01 00:00:00 UTC, regardless of the time zone associated with datetime.

Since glibmm 2.26:

Returns:
  The Unix time corresponding to datetime.

DateTime Glib::DateTime::to_utc | ( |  | ) | const

Creates a new DateTime corresponding to the same instant in time as datetime, but in UTC.

This call is equivalent to calling g_date_time_to_timezone() with the time zone returned by g_time_zone_new_utc().

Since glibmm 2.26:

Returns:
  The newly created DateTime.

## Friends And Related Function Documentation

Glib::DateTime wrap | ( | GDateTime * | object,
|  | bool | take_copy = `false`
| ) |  | `[related]`

A Glib::wrap() method for this object.

Parameters:

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns:
  A C++ instance that wraps this C instance.

## Member Data Documentation

GDateTime* Glib::DateTime::gobject_`[protected]`